Package serp.bytecode

# Class LoadInstruction

java.lang.Object
serp.bytecode.Instruction
serp.bytecode.TypedInstruction
serp.bytecode.LocalVariableInstruction
serp.bytecode.LoadInstruction

All Implemented Interfaces:
  `BCEntity`, `VisitAcceptor`

public class LoadInstruction extends LocalVariableInstruction
Loads a value from the locals table to the stack.

Author:
  Abe White

## Method Summary

Modifier and Type
Method
Description
`void`
`acceptVisit(BCVisitor visit)`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.
`boolean`
`equalsInstruction(Instruction other)`
LoadInstructions are equal if the type they reference the same type and locals index or if either is unset.
`int`
`getLogicalStackChange()`
Return the logical number of stack positions changed by this instruction.
`int`
`getStackChange()`
Return the number of stack positions this instruction pushes or pops during its execution.
`String`
`getTypeName()`
Return the type name for this instruction.
`boolean`
`isThis()`
Equivalent to `getLocal () == 0 invalid input: '&'invalid input: '&' getType () == Object.class`; the `this` ptr is always passed in local variable 0.
`LoadInstruction`
`setThis()`
Equivalent to `setLocal (0).setType (Object.class)`; the `this` ptr is always passed in local variable 0.
`TypedInstruction`
`setType(String type)`
Set the type of this instruction.

### Methods inherited from class serp.bytecode.LocalVariableInstruction

`getLocal, getLocalVariable, getParam, setLocal, setLocalVariable, setParam`

### Methods inherited from class serp.bytecode.TypedInstruction

`getType, getTypeBC, setType, setType`

### Methods inherited from class serp.bytecode.Instruction

`getByteIndex, getClassLoader, getCode, getLineNumber, getName, getOpcode, getPool, getProject, isValid`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getStackChange

public int getStackChange()
Description copied from class: `Instruction`
Return the number of stack positions this instruction pushes or pops during its execution.

Overrides:
  `getStackChange` in class `Instruction`
Returns:
  0 if the stack is not affected by this instruction, a positive number if it pushes onto the stack, and a negative number if it pops from the stack

### getLogicalStackChange

public int getLogicalStackChange()
Description copied from class: `Instruction`
Return the logical number of stack positions changed by this instruction. In other words, ignore weirdness with longs and doubles taking two stack positions.

Overrides:
  `getLogicalStackChange` in class `Instruction`

### getTypeName

public String getTypeName()
Description copied from class: `TypedInstruction`
Return the type name for this instruction. If the type has not been set, this method will return null.

Overrides:
  `getTypeName` in class `LocalVariableInstruction`

### setType

public TypedInstruction setType(String type)
Description copied from class: `TypedInstruction`
Set the type of this instruction. Types that have no direct support will be converted accordingly.

Overrides:
  `setType` in class `LocalVariableInstruction`
Returns:
  this instruction, for method chaining

### setThis

public LoadInstruction setThis()
Equivalent to `setLocal (0).setType (Object.class)`; the `this` ptr is always passed in local variable 0.

Returns:
  this instruction, for method chaining

### isThis

public boolean isThis()
Equivalent to `getLocal () == 0 invalid input: '&'invalid input: '&' getType () == Object.class`; the `this` ptr is always passed in local variable 0.

### equalsInstruction

public boolean equalsInstruction(Instruction other)
LoadInstructions are equal if the type they reference the same type and locals index or if either is unset.

Overrides:
  `equalsInstruction` in class `LocalVariableInstruction`

### acceptVisit

public void acceptVisit(BCVisitor visit)
Description copied from interface: `VisitAcceptor`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.

Specified by:
  `acceptVisit` in interface `VisitAcceptor`
Overrides:
  `acceptVisit` in class `Instruction`